// ----------------------------------------------------------------------------

static bool isNumeric(char* sz_value) {

	for (int i=0; sz_value[i] != 0; i++) {
		char c = sz_value[i];
		if ((c >= '0' && c <= '9') ||
			(c == ' ' || c == '-' || c == '+')) {
		} else {
			return false;
		}
	}

	return true;

}

// ----------------------------------------------------------------------------

/**
 *  Parse this 1D array initializer string and allocate and fill 1d array with data
 */
template <typename T>
array_1d<T>::array_1d(char* sz_initializer)  :
		pa_data(NULL),
		offset(0),
		owns_data(false),
		length(0),
		dimensionality(1)
	{

	// find array element length
	int _length = 1;
	for (int i=0; sz_initializer[i]!=0; i++) {
		if ( sz_initializer[i] == ',' ) {
			_length++;
		}
	}

	// allocate data
	allocate(_length);
	//printf("array_1d<T>[%d] = %s\n", length, sz_initializer);


	JStringPtr strInitializer(sz_initializer);

	// remove leading '{' and trailing '}'
	strInitializer = strInitializer->substring(1, strInitializer->length()-1);
	//printf("%s\n", strInitializer->getNativeCharPtr() );

	// parse the array elements
	int a = 0;
	int b = strInitializer->length()-1;

	for (int i=0; i<length; i++) {

		// find the end of this data, either next comma or end of string
		b = strInitializer->indexOf(',', a);
		if (b==-1) b = strInitializer->length();

		// extract this element's string value
		JStringPtr strValue = strInitializer->substring(a,b)->trim();

		// valid string data for integer type?
		if ( isNumeric( strValue->getNativeCharPtr() ) ) {

			// assign element to parsed data
			(*this)[i] = Integer::parseInt( strValue );

			//printf("parsing: '%s' = %d\n", strValue->getNativeCharPtr(), (*this)[i] );

		} else { // error parsing string, data is not numberic!

			(*this)[i] = 0;
			printf("Failed parsing: '%s' = %d\n", strValue->getNativeCharPtr(), (*this)[i] );

		}

		a = b + 1; // move onto next element
	}
}

/*template <bool>
array_1d<bool>::array_1d(char* sz_initializer)  :
		pa_data(NULL),
		offset(0),
		owns_data(false),
		length(0),
		dimensionality(1)
	{

	// find array element length
	int _length = 1;
	for (int i=0; sz_initializer[i]!=0; i++) {
		if ( sz_initializer[i] == ',' ) {
			_length++;
		}
	}

	// allocate data
	allocate(_length);
	//printf("array_1d<T>[%d] = %s\n", length, sz_initializer);


	JStringPtr strInitializer(sz_initializer);

	// remove leading '{' and trailing '}'
	strInitializer = strInitializer->substring(1, strInitializer->length()-1);
	//printf("%s\n", strInitializer->getNativeCharPtr() );

	// parse the array elements
	int a = 0;
	int b = strInitializer->length()-1;

	for (int i=0; i<length; i++) {

		// find the end of this data, either next comma or end of string
		b = strInitializer->indexOf(',', a);
		if (b==-1) b = strInitializer->length();

		// extract this element's string value
		JStringPtr strValue = strInitializer->substring(a,b)->trim();

		// valid string data for integer type?
		if ( isNumeric( strValue->getNativeCharPtr() ) ) {

			// assign element to parsed data
			(*this)[i] = true;

			//printf("parsing: '%s' = %d\n", strValue->getNativeCharPtr(), (*this)[i] );

		} else { // error parsing string, data is not numberic!

			(*this)[i] = fals;
			printf("Failed parsing: '%s' = %d\n", strValue->getNativeCharPtr(), (*this)[i] );

		}

		a = b + 1; // move onto next element
	}
}*/


// ----------------------------------------------------------------------------

/** initialize from java style initializer string constructor */
template <typename T>
array_2dvariable<T>::array_2dvariable(char* sz_initializer, int length) :
array_1d<array_1d_ptr<T> >(length) {
	
	printf("array_2dvariable<T>(%d) = \n", length);
	
	JStringPtr strInitializer(sz_initializer);
	
	int start = strInitializer->indexOf('{') + 1;
	//int end = strInitializer->lastIndexOf('}');
	
	for (int i=0; i<length; i++) {
		
		int open_brace = strInitializer->indexOf('{', start);
		int close_brace = strInitializer->indexOf('}', open_brace) + 1;
		
		JStringPtr strRow = strInitializer->substring(open_brace, close_brace);
		
		printf("[%d] = %s\n", i, strRow->getNativeCharPtr());
		
		// assign this row to a new array 1d created from the sub-array string data
		(*this)[i] = new array_1d_ptr<T>(strRow->getNativeCharPtr());
		
		start = close_brace;
		
	}
	
}

